
_G[gTable] = {};

local aTmpVal  = gTable;
local aState   = 0;
cm.SetupTable(_G[aTmpVal]);

-- Called on Init
_G[gTable].OnInit = function(pObj)
	aState = pObj.mState;
end


-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)
	aState = pObj.mState;
end

--Called after level being reloaded
_G[gTable].OnLevelLoad = function(pObj)
	aState = pObj.mState;
end

-- Called on a update
_G[gTable].OnUpdate = function(pObj)


end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	pObj.mDiscovered = true;

	if pName == "" then

      if aState == 0 then
	      cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
	      return true;

   	elseif aState == 1 then

         aState           = aState + 1;
   		pObj.mState		  = aState;
   		pObj.mCurCell	  = pObj.mCurCell + 1;
   		cm.SetGlobalValIndirect(pObj, "SetFlag1", true);
         cm.DisableObject(pObj);
   		IcPlaySample("PH_SFX_LEVEROPERATED2");
   		return true;
   	end

      cm.ObjDoesNotWork(pObj);
   	return true;

   -- The chest is unlocked
	elseif pName == pObj.mCsData:GetString("KeyObject1") then

      if aState == 0 then

         if not cm.GetGlobalBoolIndirect(pObj, "ActivatorFlag1") then
            cm.GetShowInfo(pObj, "InfoStr2", "InfoTime2");
            IcPlaySample("PH_SFX_DOES_NOT_WORK");
            return false;
         end

         aState           = aState + 1;
   		pObj.mState		  = aState;
   		pObj.mCurCell	  = pObj.mCurCell + 1;

   		pObj:SetActive(0, pPolyNum, false);
   		pObj:SetActive(0, pPolyNum + 1, true);
   		pObj:StopParticleEmission(false);

   		_G[pActorObj.mScriptTag].OnUse(pActorObj, pObj);
   		return true;
		end

		cm.ObjDoesNotWork(pObj);
		return false;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

	return false;
end



-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aRpos = pObj.mSmPos;
	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRect = aImg:GetCelRect(pObj.mCurCell);
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);


end



-- Zooms Out
_G[gTable].NormalSize = cm.ZoomOut;


-- Zooms In
_G[gTable].GetBigger = cm.ZoomIn;


